% !TEX TS-program = pdflatex
% !TeX encoding = UTF-8
% !TeX spellcheck = en_GB

\documentclass[aspectratio=43]{beamer}
% use this instead for 16:9 aspect ratio:
%\documentclass[aspectratio=169]{beamer}
% supported aspect ratios  1610  169 149 54 43 (default) 32
%

\usepackage[english]{babel} 
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc} 	
\usepackage{listings}
\usepackage{todonotes}
\usetheme{ETHbeamer}

\colorlet{ETHcolor1}{ETHc}
\colorlet{ETHcolor2}{ETHc}

\author{L. Bieri \and L. Gehri \and D. Portenier \and I. Boschung}

\title{System Review of Group 12 by Group 14}

\date{2021-12-23}




\definecolor{codecomment}{RGB}{125, 125, 125}
\definecolor{codenumbers}{RGB}{125, 125, 125}
\definecolor{codestring}{RGB}{7, 177, 95}
\definecolor{codeemphtypes}{RGB}{44, 162, 211}
\definecolor{codeemphoperators}{RGB}{214, 123, 236}
\definecolor{codekeywords}{RGB}{9, 20, 214}



\lstdefinestyle{mystyle}{
	language=Python,
	commentstyle=\color{codecomment},
	keywordstyle=\color{codekeywords},
	numberstyle=\color{codenumbers},
	stringstyle=\color{codestring},
	emph={int,char,double,float,unsigned, bool},
	emphstyle={\color{codeemphtypes}},
	emph={[2]'+', +, \+, \plus},
	emphstyle={[2]\color{codeemphoperators}},
	basicstyle=\footnotesize,
	breakatwhitespace=false,         
	breaklines=true,   
	captionpos=b,                                  
	keepspaces=true,                 
	numbers=false,                    
	numbersep=5pt,                  
	showspaces=false,                
	showstringspaces=false,
	showtabs=false,
	aboveskip=0pt,  
	belowskip=-0pt,
	xleftmargin=15pt,                
	tabsize=2
}
\lstset{style=mystyle}


% uncomment if you do not want to use a department logo
%\deplogofalse


\begin{document}

\titleframe

\begin{frame}{Overview}
\begin{itemize}
    \item Short System Description
    \item Blackbox Analysis
    \item Whitebox Analysis
    \item Backdoors
\end{itemize}
    
\end{frame}





\begin{frame}{Short System Description \small{ - only the important parts}}
\begin{columns}[T]
    \begin{column}{.5\textwidth}
    \begin{itemize}
        \item Security relies a lot on isolated network
        \item Web server proxies requests (SSH-Jumphost)
        \item Backup using BorgBackup
    \end{itemize}
    \end{column}
    \begin{column}{.5\textwidth}
%        \begin{figure}
            \centering
            \includegraphics[width=\textwidth]{Pictures/their_setup.png}
            \caption{Source: Report group 12}
%        \end{figure}
    \end{column}
\end{columns}
\end{frame}





\begin{frame}{Blackbox Analysis}
\begin{columns}[T]
    \begin{column}{1\textwidth}

        \begin{itemize}
            \item Communication only with web server
            \item Deleting foreign certificates
            \item Client side hashing of passwords  \\ (still unknown if rehashed server side)
        \end{itemize}
    \end{column}
 
\end{columns}
\end{frame}







\begin{frame}{Whitebox Analysis}
\begin{columns}[T]
    \begin{column}{\textwidth}
        \begin{itemize}
            \item Backdoors - later
            \item Confirmation: deleting foreign certificates 
            \item Confirmation: client side only hashing
            \item BorgBackup privilege escalation
            \begin{itemize}
                \item possible from web server, database server, and CA server
                \item borgbackup user with password borgbackup
                \item SSH connection to backup server as borg user
            \end{itemize}
        \end{itemize}
            \end{column}
   
\end{columns}
\end{frame}



\begin{frame}[fragile]{Backdoor: Shell Injection Attack}
\begin{itemize}
    \item Revoke any certificate
    \item Terminate command and execute any shell command

\end{itemize}
\begin{columns}[T]
    \begin{column}{\textwidth}

    \begin{lstlisting}
@app.route('/revoke', methods=['GET'])
def revoke_cert():
    json_dict = request.get_json()
    revoke_serial = json_dict["serial"]
    
    TO_REVOKE_FILE = "CA/newcerts/{}.pem".format(revoke_serial)
    os.system("openssl ca -revoke {} -config {}".format(TO_REVOKE_FILE, OPENSSL_CONF_FILE))
    [...]
    \end{lstlisting}

    \end{column}
\end{columns}
\end{frame}






\begin{frame}[fragile]{Backdoors: SQL Injection in DB Connector}
\begin{columns}[T]
    \begin{column}{\textwidth}
\begin{itemize}
    \item Function called with unsanitized arguments 
    \item Web server acts as quasi-reverse-proxy. $\rightarrow$ no access
\end{itemize}

    \begin{lstlisting}
def add_certificate(self, serial, uid):
    query = ("INSERT INTO certificates VALUES (%(serial)s, %(uid)s);".format(serial, uid))
    try:
        self.cursor.execute(query, {"serial": serial, "uid": uid})
        self.cnx.commit()
    ...\end{lstlisting}
    \end{column}
\end{columns}
\end{frame}




\begin{frame}[fragile]{Backdoors: Theoretical Race Condition}
\begin{columns}[T]
    \begin{column}{\textwidth}
    \begin{itemize}
        \item Flask multithreading
        \item Simultaneous request of certificate
    \end{itemize}
    \begin{lstlisting}
    def create_cert(username, email):
    ... 
    private_key_file = "CA/private/temkey.pem"
    with open(private_key_file, "wb") as file:
        file.write(crypto.dump_privatekey(crypto.FILETYPE_PEM, k))
    # ... some calculations involving scp
    os.system("openssl pkcs12 -export -out {} -inkey {} -in {} -passout pass: -certfile CA/revoked.pem > /dev/null".format(
        pkcs_file, private_key_file, cert_file))
    ...\end{lstlisting}

    \end{column}
\end{columns}
\end{frame}








\end{document}
